VERSION 5.00
Begin VB.Form frHodiny 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   8400
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8400
   ForeColor       =   &H00FFFFFF&
   Icon            =   "HODINY.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   Picture         =   "HODINY.frx":0442
   ScaleHeight     =   560
   ScaleMode       =   0  'User
   ScaleWidth      =   560
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer tmHodiny 
      Interval        =   1000
      Left            =   120
      Top             =   120
   End
   Begin VB.Label lbDatum 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "28.12.2002"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFF00&
      Height          =   360
      Left            =   3480
      TabIndex        =   0
      Top             =   5520
      Width           =   1515
   End
   Begin VB.Line lnHod 
      BorderColor     =   &H00FFFFFF&
      BorderWidth     =   9
      X1              =   280
      X2              =   208
      Y1              =   280
      Y2              =   340
   End
   Begin VB.Line lnMin 
      BorderColor     =   &H00FFFFFF&
      BorderWidth     =   3
      X1              =   280
      X2              =   436
      Y1              =   280
      Y2              =   200
   End
   Begin VB.Line lnSec 
      BorderColor     =   &H00FFFFFF&
      X1              =   280
      X2              =   452
      Y1              =   280
      Y2              =   452
   End
End
Attribute VB_Name = "frHodiny"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const gPi As Double = 3.14159265358979



Private Sub Form_Load()

   Dim lR As Long   ' Handler regionu
   Dim lT As Long   ' Prvn pixel shora vnitku formule
   Dim lL As Long   ' Prvn pixel zleva vnitku formule
   Dim lW As Long   ' ka formule v pixelech
   Dim lH As Long   ' Vka formule v pixelech
   
   ' Po sputn se potky ruiek umst do stedu formule ...
   With Me.lnSec: .X1 = Me.ScaleWidth / 2: .X2 = Me.ScaleHeight / 2: End With
   With Me.lnMin: .X1 = Me.ScaleWidth / 2: .X2 = Me.ScaleHeight / 2: End With
   With Me.lnHod: .X1 = Me.ScaleWidth / 2: .X2 = Me.ScaleHeight / 2: End With
   
   ' ... a zobraz se sprvn as a datum:
   ZobrazCas Me
   
   ' Parametry okrajujc elipsy
   lW = Me.ScaleX(Me.Width, vbTwips, vbPixels) - 4
   lH = Me.ScaleY(Me.Height, vbTwips, vbPixels) - 4
   lL = 4
   lT = lH - Me.ScaleY(Me.ScaleHeight, Me.ScaleMode, vbPixels) + 2
   
   ' Ukrojen vnjku hodin
   lR = CreateEllipticRgn(lL, lT, lW, lH)
   SetWindowRgn Me.hwnd, lR, True
   
End Sub



Private Sub Form_DblClick()

   ' Po dbl clicknut kamkoliv do formule je monost skonit:

   Dim lOdp As Long
   Dim lT As String
   
   lOdp = MsgBox("Skonit?", vbQuestion + vbYesNo, "Co je?")
   If lOdp = vbYes Then Unload Me
   
End Sub



Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
   ' Hbn hodinama pi formuli bez nadpisu
   ReleaseCapture
   SendMessage Me.hwnd, WM_SYSCOMMAND, &HF012&, 0&
End Sub



Private Sub tmHodiny_Timer()
   ' Po uplynut nastavenho intervalu timeru se udl co?
   ZobrazCas Me
End Sub



Private Sub ZobrazCas(qF As Form)

   ' Nastav koncov body ruiek do bod odpovdajcch aktulnmu asu.

   Dim lX As Double
   Dim lY As Double
   Dim lCx As Double
   Dim lCy As Double
   Dim lC As String
   Dim lT
   
   lT = Now()
   qF.Caption = Format(lT, "hh:mm:ss")
   qF.lbDatum.Caption = Format(lT, "dd/mm/yyyy")

   KonSec qF, lT, 5, lX, lY: With qF.lnSec: .X2 = lX: .Y2 = lY: End With
   KonMin qF, lT, 15, lX, lY: With qF.lnMin: .X2 = lX: .Y2 = lY: End With
   KonHod qF, lT, 25, lX, lY: With qF.lnHod: .X2 = lX: .Y2 = lY: End With

End Sub



Private Sub KonSec(qF As Form, qT, qP As Double, ByRef qX As Double, ByRef qY As Double)
   
   ' Spote souadnice koncovho bodu vteinov ruiky v ase qT,
   ' piem dlka ruiky je o qP% men ne "polomr" formule qF.
   
   Dim lA As Double
   Dim lB As Double
   Dim lF As Double
   Dim lP As Double
   Dim lS As Double
   
   lS = Second(qT)
   lP = lS * 2 * gPi / 60
   lF = IIf(lS >= 0 And lS < 45, gPi - lP, 3 * gPi - lP)
   
   lA = qF.ScaleWidth * (50 - qP) / 100
   lB = qF.ScaleHeight * (50 - qP) / 100
   qX = lA * Sin(lF) + qF.ScaleWidth / 2
   qY = lB * Cos(lF) + qF.ScaleHeight / 2
   
End Sub



Private Sub KonMin(qF As Form, qT, qP As Double, ByRef qX As Double, ByRef qY As Double)
   
   ' Spote souadnice koncovho bodu minutov ruiky v ase qT,
   ' piem dlka ruiky je o qP% men ne "polomr" formule qF.
   
   Dim lA As Double
   Dim lB As Double
   Dim lF As Double
   Dim lP As Double
   Dim lS As Double
   
   lS = Minute(qT)
   lP = lS * 2 * gPi / 60
   lF = IIf(lS >= 0 And lS < 45, gPi - lP, 3 * gPi - lP)
   
   lA = qF.ScaleWidth * (50 - qP) / 100
   lB = qF.ScaleHeight * (50 - qP) / 100
   qX = lA * Sin(lF) + qF.ScaleWidth / 2
   qY = lB * Cos(lF) + qF.ScaleHeight / 2
   
End Sub



Private Sub KonHod(qF As Form, qT, qP As Double, ByRef qX As Double, ByRef qY As Double)
   
   ' Spote souadnice koncovho bodu hodinov ruiky v ase qT,
   ' piem dlka ruiky je o qP% men ne "polomr" formule qF.
      
   Dim lA As Double
   Dim lB As Double
   Dim lF As Double
   Dim lP As Double
   Dim lS As Double
   
   lS = (Hour(qT) * 60 + Minute(qT)) / 60: If lS >= 12 Then lS = lS - 12
   lP = lS * 2 * gPi / 12
   lF = IIf(lS >= 0 And lS < 45, gPi - lP, 3 * gPi - lP)
   
   lA = qF.ScaleWidth * (50 - qP) / 100
   lB = qF.ScaleHeight * (50 - qP) / 100
   qX = lA * Sin(lF) + qF.ScaleWidth / 2
   qY = lB * Cos(lF) + qF.ScaleHeight / 2
   
End Sub

